# React + TypeScript + Vite

This template provides a minimal setup to get React working in Vite with HMR and some ESLint rules.

Currently, two official plugins are available:

- [@vitejs/plugin-react](https://github.com/vitejs/vite-plugin-react/blob/main/packages/plugin-react/README.md) uses [Babel](https://babeljs.io/) for Fast Refresh
- [@vitejs/plugin-react-swc](https://github.com/vitejs/vite-plugin-react-swc) uses [SWC](https://swc.rs/) for Fast Refresh

## Make commands

The following commands will automatically install all dependencies if missing or changed.

- `make` or `make dev`: Run dev server
- `make update`: Force update of the dependencies.
- `make preview`: Locally preview the production build.
- `make build`: Build the site. Will be stored in `dist/`. This will also run the linter.
- `make build-prod`: Build the site ready for production. Also does a clean install of the dependencies via `package-lock.json`. Will also be stored in `dist/`.
- `make lint`: Run the linter.
- `make clean`: Remove `dist/` and `node_modules/`.

## Links

- https://vitejs.dev/guide/
- https://jsonforms.io/
- https://vitejs.dev/guide/build.html#multi-page-app
- https://reactrouter.com/en/main/start/tutorial
- https://www.npmjs.com/package/react-toastify
- https://fkhadra.github.io/react-toastify/introduction/
- https://ui.shadcn.com/docs/installation/vite
- https://jsonforms-editor.netlify.app/
- https://github.com/eclipsesource/jsonforms-editor
- https://jsonformseditor.io/


## Expanding the ESLint configuration

If you are developing a production application, we recommend updating the configuration to enable type aware lint rules:

- Configure the top-level `parserOptions` property like this:

```js
export default tseslint.config({
  languageOptions: {
    // other options...
    parserOptions: {
      project: ['./tsconfig.node.json', './tsconfig.app.json'],
      tsconfigRootDir: import.meta.dirname,
    },
  },
})
```

- Replace `tseslint.configs.recommended` to `tseslint.configs.recommendedTypeChecked` or `tseslint.configs.strictTypeChecked`
- Optionally add `...tseslint.configs.stylisticTypeChecked`
- Install [eslint-plugin-react](https://github.com/jsx-eslint/eslint-plugin-react) and update the config:

```js
// eslint.config.js
import react from 'eslint-plugin-react'

export default tseslint.config({
  // Set the react version
  settings: { react: { version: '18.3' } },
  plugins: {
    // Add the react plugin
    react,
  },
  rules: {
    // other rules...
    // Enable its recommended rules
    ...react.configs.recommended.rules,
    ...react.configs['jsx-runtime'].rules,
  },
})
```
